<?php
ini_set("display_errors",0);//only response from this page must be "OK"
//error_reporting(E_ALL);

if (version_compare(PHP_VERSION, '5.3.1', '<'))
{
	die('Your host needs to use PHP 5.3.1 or higher to run this version of Joomla!');
}
if(!defined('_JEXEC'))
{
  define('_JEXEC', 1);
}
defined( '_JEXEC' ) or die( 'Restricted access' );
define('DS', DIRECTORY_SEPARATOR);
$dirname=str_ireplace(DS.'plugins'.DS.'vmpayment'.DS.'payuczechforvirtuemart','', dirname(__FILE__));

if (file_exists($dirname.DS.'defines.php'))
{
	include_once $dirname.DS.'defines.php';
}
if (!defined('_JDEFINES'))
{
	define('JPATH_BASE', $dirname);
	require_once JPATH_BASE.DS.'includes/defines.php';
}
require_once JPATH_BASE.DS.'includes/framework.php';
// Mark afterLoad in the profiler.
JDEBUG ? $_PROFILER->mark('afterLoad') : null;
// Instantiate the application.
$app = JFactory::getApplication('site');

$session_id=isset($_GET['session_id'])?$_GET['session_id']:"";
if($session_id=='')
{
  $session_id=isset($_POST['session_id'])?$_POST['session_id']:"";
}

if($session_id=='')
{
  echo "OK";
  exit;
}

defined('JPATH_VM_LIBRARIES') or define ('JPATH_VM_LIBRARIES', JPATH_LIBRARIES);
defined('JPATH_VM_ADMINISTRATOR') or define('JPATH_VM_ADMINISTRATOR', JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_virtuemart');
if (!class_exists( 'VmConfig' )) require(JPATH_VM_ADMINISTRATOR.DS.'helpers'.DS.'config.php');
if (!class_exists('VirtueMartModelOrders')) {
	require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
}
defined('JPATH_COMPONENT') or define ('JPATH_COMPONENT', JPATH_ROOT.DS.'components'.DS.'com_virtuemart');


if (!($virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($session_id))) {
	echo "OK";
  exit;
}
$db = JFactory::getDBO ();
$q = "SELECT virtuemart_paymentmethod_id FROM #__virtuemart_orders WHERE `virtuemart_order_id` = " . $virtuemart_order_id;
$db->setQuery ($q);
$res = $db->loadObject();
$virtuemart_paymentmethod_id=0;
if (isset($res->virtuemart_paymentmethod_id)) {
	$virtuemart_paymentmethod_id=$res->virtuemart_paymentmethod_id;
}
else
{
  echo "OK";
  exit;
}

$payment_params="";
$q = "SELECT payment_params FROM #__virtuemart_paymentmethods WHERE `virtuemart_paymentmethod_id` = " . $virtuemart_paymentmethod_id;
$db->setQuery ($q);
$res = $db->loadObject();

if (isset($res->payment_params)) {
	$payment_params=$res->payment_params;
}
else
{
  echo "OK";
  exit;
}
if(!$payment_params)
{
  echo "OK";
  exit;
}

$method=new stdClass;
$tarr=array();
$tarr=explode("|",$payment_params);
foreach($tarr as $t)
{
  $tarr1=array();
  $tarr1=explode('="',$t);
  if(count($tarr1)==2)
  {
    $method->$tarr1[0]=substr($tarr1[1],0,-1);
  }
}

$sig_ext=isset($_POST['sig_ext'])?$_POST['sig_ext']:"";
$ts=isset($_POST['ts'])?$_POST['ts']+0:0;
$sig_ext_order=isset($_POST['sig_ext_order'])?$_POST['sig_ext_order']:"";
$pos_id=isset($_POST['pos_id'])?$_POST['pos_id']:"";
$sig=isset($_POST['sig'])?$_POST['sig']:"";

$key1=$method->payu_key2;
$sig_check = md5($pos_id.$session_id.$ts.$key1);

$order_paid=0;

if($sig_check==$sig)
{
  $curl_problem=0;
  // check the status
  if(function_exists('curl_init'))
  {
    $url = "https://secure.payu.com/paygw/UTF/Payment/get/txt";
    $stamp=time();
    $sig=md5($method->payu_user.$session_id.$stamp.$method->payu_key);
    $post_fields='pos_id='.$method->payu_user.'&session_id='.$session_id.'&ts='.$stamp.'&sig='.$sig;
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $post_fields);
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_TIMEOUT, 20);
    $result = curl_exec($ch);
    curl_close($ch);
    if($result && $result!="")
    {
      $pos=strpos($result, "trans_status: 99");
      if($pos===false)
      {
        //not ok, don't do anything
        /*
        $mailer = JFactory::getMailer();
        $config = JFactory::getConfig();
        $sender = array( 
            $config->get( 'mailfrom' ),
            $config->get( 'fromname' ) );
         
        $mailer->setSender($sender);
        $body="";
        $mailer->addRecipient($config->get( 'mailfrom' ));
        $body   = print_r($_POST,true);
        $mailer->setSubject("PayU Czech Notify Debug");
        $mailer->isHTML(true);
        $body=nl2br($body);
        $mailer->setBody($body);
        $send = $mailer->Send();
        */
      }
      else
      {
        $order_paid=1;
      }
    }
    else
    {
      $curl_problem=1;
    }
  }
  else
  {
    $curl_problem=1;
  }
  if($curl_problem==1)
  {
    $mailer = JFactory::getMailer();
    $config = JFactory::getConfig();
    $sender = array( 
        $config->get( 'mailfrom' ),
        $config->get( 'fromname' ) );
     
    $mailer->setSender($sender);
    $body="";
    $mailer->addRecipient($config->get( 'mailfrom' ));
    //$body   = print_r($_POST,true);
    $mailer->setSubject("PayU Czech Notify cUrl ERROR");
    $mailer->isHTML(true);
    $body="Please note that cUrl must be enabled on your server, it is required for communicating with the PayU server for checking the transaction status<br />Requested URL is: https://secure.payu.com/paygw/UTF/Payment/get/txt";
    //.nl2br($body);
    $mailer->setBody($body);
    $send = $mailer->Send();
  }
}

if($order_paid==1)
{
	$modelOrder = VmModel::getModel('orders');
	$order = array();
  $order['comments'] = '';
	$order['customer_notified'] = 1;
	$order['order_status'] = $method->status_success;
	$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, TRUE);
}
?>
OK